-- By D4KiR

function ToCurrentChat(str)
	local _channel = "SAY"
	local inInstance, instanceType = IsInInstance()

	if inInstance then
		if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
			_channel = "INSTANCE_CHAT"
		else
			if instanceType == "raid" then
				_channel = "RAID"
			elseif instanceType == "party" then
				_channel = "PARTY"
			end
		end
	else
		if UnitInRaid("player") then
			_channel = "RAID"
		elseif UnitInParty("player") then
			_channel = "PARTY"
		end
	end
	if _channel ~= "SAY" then
		SendChatMessage("[" .. D4_HP.name .. "] " .. str, _channel)
	end
end

local setup = false
function Setup()
	if not setup then
		setup = true
		print("|cff8888ffSetup " .. D4_HP.name)

		warning_aggro = CreateFrame("FRAME", nil, UIParent)
		warning_aggro:SetFrameStrata("BACKGROUND")
		warning_aggro:SetWidth(128)
		warning_aggro:SetHeight(64)

		warning_aggro.text = warning_aggro:CreateFontString(nil, "ARTWORK")
		warning_aggro.text:SetFont(STANDARD_TEXT_FONT, 20, "OUTLINE")
		warning_aggro.text:SetPoint("CENTER", 0, 340)
		warning_aggro.text:SetText(D4_HP.GT("youhaveaggro") .. "!")
		warning_aggro.text:SetTextColor(1, 0, 0, 1)

		hooksecurefunc("UpdateLanguage", function()
			warning_aggro.text:SetText(D4_HP.GT("youhaveaggro") .. "!")
		end)

		warning_aggro:SetPoint("CENTER", 0, 0)
		warning_aggro:Hide()

		D4_HP.InitSetting()

		D4_HP.Lang_enEN()
		if GetLocale() == "deDE" then
			D4_HP.msg("Language detected: deDE (Deutsch)")
			D4_HP.Lang_deDE()
		end
		UpdateLanguage()
	end
end
hooksecurefunc("UnitFramePortrait_Update", Setup)

local nearoom = false
local oom = false
local aggro = false
function pChat()
	if setup and warning_aggro ~= nil then
		local roleToken = GetSpecializationRole(GetSpecialization())
		if UnitGroupRolesAssigned("player") == "HEALER" or roleToken == "HEALER" then
			-- Aggro Logic
			if D4HP.AGGRO then
				local status = UnitThreatSituation("player")
				local hp = UnitHealth("player")
				local hpmax = UnitHealthMax("player")
				local hpperc = hp / hpmax * 100
				if status ~= nil then
					if status > 0 and not aggro then
						aggro = true
						if hpperc < D4HP.AGGROPercentage then
							ToCurrentChat(D4_HP.GT("ihaveaggro"))
						end
					elseif status == 0 and aggro then
						aggro = false
					end
				else
					aggro = false
				end
				if aggro then
					warning_aggro:Show()
				else
					warning_aggro:Hide()
				end
			else
				warning_aggro:Hide()
			end

			-- MANA Logic
			local _, powerToken, _, _, _ = UnitPowerType("player")
			if powerToken == "MANA" then
				local mana = UnitPower("player")
				local manamax = UnitPowerMax("player")
				local manaperc = math.round((mana / manamax) * 100, 1)

				-- Near OOM
				if D4HP.NEAROOM then
					if manaperc <= D4HP.NEAROOMPercentage and not nearoom then
						nearoom = true
						local tab = {}
						tab["MANA"] = manaperc
						ToCurrentChat(D4_HP.GT("iamnearoom") .. " (" .. D4_HP.GT("xmana", tab) .. ").")
					elseif manaperc > D4HP.NEAROOMPercentage + 20 and nearoom then
						nearoom = false
					end
				end

				-- OOM
				if D4HP.OOM then
					if manaperc <= D4HP.OOMPercentage and not oom then
						oom = true
						local tab = {}
						tab["MANA"] = manaperc
						if D4HP.NEAROOM then
							ToCurrentChat(D4_HP.GT("iamoom") .. " (" .. D4_HP.GT("xmana", tab) .. ").")
						end
					elseif manaperc > D4HP.OOMPercentage + 20 and oom then
						oom = false
					end
				end
			end
		end
	end
end
C_Timer.NewTicker(1, pChat)

print("|c0000ffffLoaded |c008888ff" .. D4_HP.name .. "|c0000ffff by |c008888ff" .. D4_HP.author .. "|c0000ffff!")
